#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Author:   fidojones
# Version:   0.1
# Homepage: http://fidojones.com
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License version 3        #
#    as published by the Free Software Foundation.                         #

import sys
from PyQt4 import QtCore, QtGui
import httplib2  
import feedparser
import os
import webbrowser
import ConfigParser
import pyDes
from lock_file import LockFile, LockError

url = 'https://www.google.com/bookmarks/?output=rss&num=1000'
prog_name = os.path.basename(sys.argv[0])
prog_version = "0.1"
cfg_file=os.environ['HOME']+'/.config/pygbookmarks.cfg'
ruta_images=''

class configFile:
	def __init__( self ):
		if os.path.exists(cfg_file):
			self.config = ConfigParser.ConfigParser()
			self.config.read([cfg_file])
			self.cfg_usuario=self.get_usuario()
			self.cfg_password=self.get_password()
		else:
			self.cfg_usuario=""
			self.cfg_password=""

	def set_usuario(self,usuario):
		self.cfg_usuario=usuario

	def set_password(self,password):
		self.cfg_password=password

	def get_usuario(self):
		return self.config.get("general","usuario")
		
	def get_password(self):
		self.crypto = pyDes.des("DESCRYPT", pyDes.CBC, "\0\0\0\0\0\0\0\0")
		try:
			self.password=self.crypto.decrypt(self.config.get("general","password"),"*")
		except:
			self.password=""
		return self.password

	def save(self):
		self.cfgsave=None
		self.cfgsave = ConfigParser.ConfigParser()
		self.cfgsave.add_section("general")
		self.cfgsave.set("general", "usuario", self.cfg_usuario)
		#Encriptamos password
		self.crypto = pyDes.des("DESCRYPT", pyDes.CBC, "\0\0\0\0\0\0\0\0")
		self.cfgsave.set("general", "password", self.crypto.encrypt(self.cfg_password,"*"))

		#Graba el fichero
		self.cfgfile=open(cfg_file, 'w')
		self.cfgsave.write(self.cfgfile)
		self.cfgfile.close()

class Bookmark:  
	def __init__(self, name, link):  
		self.name = name  
		self.link = link  

class TstModel( QtCore.QAbstractTableModel ):
	def __init__( self ):
		QtCore.QAbstractTableModel.__init__(self)

		self._header = ( 'Titulo', 'Url')
		self._itemsToKeep = 10
		self._itemIdx = 0
		self._items = [ ]

	def rowCount( self, parent ):
		return len(self._items)

	def columnCount( self, parent ):
		return len(self._header)

	def data( self, index, role ):
		if not index.isValid():
			return QtCore.QVariant()

		if role != QtCore.Qt.DisplayRole:
			return QtCore.QVariant()

		row = index.row()
		col = index.column()

		if row < 0 or row >= len(self._items) or \
			   col < 0 or col >= len(self._header):
			return QtCore.QVariant()

		return QtCore.QVariant(self._items[row][col])

	def headerData( self, section, orientation, role ):
		if orientation == QtCore.Qt.Horizontal and \
			   role == QtCore.Qt.DisplayRole:
			return QtCore.QVariant( self._header[section] )

		return QtCore.QVariant()

	def flags( self, index ):
		return QtCore.Qt.ItemIsSelectable | QtCore.Qt.ItemIsEnabled
 
class FrmConfigurar(QtGui.QDialog):
	def __init__(self, parent=None):
		QtGui.QDialog.__init__(self, parent)
		self.btngrabar = self.crearBoton(self.tr("&Grabar"), self.Grabar)
		self.btncancelar = self.crearBoton(self.tr("&Cancelar"), QtCore.SLOT("close()"))

		self.lblusuario = QtGui.QLabel(self.tr("Usuario:"))
		self.txtusuario = self.crearTextBox()
		self.lblpassword = QtGui.QLabel(self.tr("Password:"))
		self.txtpassword = self.crearTextPass()

		self.botones_capa = QtGui.QHBoxLayout()
		self.botones_capa.addStretch()
		self.botones_capa.addWidget(self.btngrabar)
		self.botones_capa.addWidget(self.btncancelar)

		self.mainLayout = QtGui.QGridLayout()
		self.mainLayout.addWidget(self.lblusuario, 0, 0)
		self.mainLayout.addWidget(self.txtusuario, 0, 1, 1, 1)
		self.mainLayout.addWidget(self.lblpassword, 1, 0)
		self.mainLayout.addWidget(self.txtpassword, 1, 1, 1, 1)
		self.mainLayout.addLayout(self.botones_capa, 2, 0, 1, 2)
		self.setLayout(self.mainLayout)

		self.setWindowTitle(self.tr("Configurar"))
		self.resize(320, 120)

		self.configuracion = configFile()
		self.txtusuario.setText(self.configuracion.cfg_usuario)
		self.txtpassword.setText(self.configuracion.cfg_password)

	def crearBoton(self, text, member):
		button = QtGui.QPushButton(text)
		self.connect(button, QtCore.SIGNAL("clicked()"), member)
		return button

	def crearTextBox(self):
		TextBox = QtGui.QLineEdit()
		TextBox.setSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Preferred)
		return TextBox

	def crearTextPass(self):
		TextBox = QtGui.QLineEdit()
		TextBox.setSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Preferred)
		TextBox.setEchoMode(QtGui.QLineEdit.Password)
		return TextBox

	def Grabar(self):
		if self.txtusuario.text()<>'' and self.txtpassword.text()<>'':
			self.configuracion = configFile()
			self.configuracion.set_usuario(str(self.txtusuario.text()))
			self.configuracion.set_password(str(self.txtpassword.text()))
			self.configuracion.save()
			self.close()
			
			#Relee los bookmarks
			myTrayicon.mnuRefrescar()
		else:
			Mensaje_Critico(self,u"Tiene que incluir el usuario y la contraseña")

class FrmBuscar(QtGui.QDialog):
	def __init__(self, parent=None):
		QtGui.QDialog.__init__(self, parent)

		self.btnbuscar = self.crearBoton(self.tr("&Buscar"), self.buscar_cadena)
		self.btncerrar = self.crearBoton(self.tr("&Cerrar"), QtCore.SLOT("close()"))

		self.txtbusqueda = self.crearTextBox()

		self.lblbuscar = QtGui.QLabel(self.tr("Buscar:"))
		self.lblencontrados = QtGui.QLabel()

		self.crearTabla()

		self.botones_capa = QtGui.QHBoxLayout()
		self.botones_capa.addStretch()
		self.botones_capa.addWidget(self.btnbuscar)
		self.botones_capa.addWidget(self.btncerrar)

		self.mainLayout = QtGui.QGridLayout()
		self.mainLayout.addWidget(self.lblbuscar, 0, 0)
		self.mainLayout.addWidget(self.txtbusqueda, 0, 1, 1, 1)
		self.mainLayout.addWidget(self.tblbusqueda, 2, 0, 2, 0)
		self.mainLayout.addWidget(self.lblencontrados, 4, 0, 1, 0)
		self.mainLayout.addLayout(self.botones_capa, 5, 0, 1, 2)
		self.setLayout(self.mainLayout)

		self.setWindowTitle(self.tr("Buscar bookmark"))
		self.resize(600,300)

	def crearBoton(self, text, member):
		button = QtGui.QPushButton(text)
		self.connect(button, QtCore.SIGNAL("clicked()"), member)
		return button

	def crearTextBox(self):
		TextBox = QtGui.QLineEdit()
		TextBox.setSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Preferred)
		return TextBox

	def crearTabla(self):
		self.modelo_busqueda = TstModel()
		self.tblbusqueda = QtGui.QTableView()
		self.tblbusqueda.setModel(self.modelo_busqueda)
		self.tblbusqueda.verticalHeader().hide()
		self.tblbusqueda.setSelectionMode(QtGui.QAbstractItemView.SelectionMode(1))
		self.tblbusqueda.setSelectionBehavior(QtGui.QAbstractItemView.SelectionBehavior(1))
		self.tblbusqueda.setAlternatingRowColors(1)
		self.tblbusqueda.setColumnWidth(0,300)
		self.tblbusqueda.setColumnWidth(1,250)
		self.connect(self.tblbusqueda, QtCore.SIGNAL("doubleClicked(QModelIndex)"), self.tblbusqueda_DoubleClick);
		
	def tblbusqueda_DoubleClick(self,index):
		url=QtCore.QVariant.toString(self.modelo_busqueda.data(self.modelo_busqueda.index(index.row(), 1, QtCore.QModelIndex()),0))
		webbrowser.open_new_tab(str(url))

	def buscar_cadena(self):
		self.modelo_busqueda._items=[]
		cadena=QtCore.QString(self.txtbusqueda.text())
		for tag in sort_keys:
			for book in direcciones[tag]:
				if book.name.lower().find(cadena) != -1:
					self.filanew=(QtCore.QVariant(book.name),QtCore.QVariant(book.link))
					self.modelo_busqueda._items.append(self.filanew)
		self.modelo_busqueda.reset()
		self.lblencontrados.setText(self.tr("%1 bookmark(s) encontrados").arg(self.modelo_busqueda.rowCount(self)))

class TrayBase(QtGui.QWidget):
	def __init__(self, *args):
		apply(QtGui.QWidget.__init__,(self, ) + args)
		self.tray = QtGui.QSystemTrayIcon(self)
		self.CrearMenu()
		self.trayIcon = QtGui.QIcon(ruta_images+"images/icn_trayicon.png")
		self.tray.setContextMenu(self.trayMenu)
		self.tray.setIcon(self.trayIcon)
		self.tray.setToolTip(u"Google Bookmarks")
		self.tray.show()
		
	def CrearMenu(self):
		self.trayMenu = QtGui.QMenu()
		self.action_configure = QtGui.QAction(QtGui.QIcon(ruta_images+"images/icn_configure.png"), u'Configurar', self)
		self.action_refresh = QtGui.QAction(QtGui.QIcon(ruta_images+"images/icn_refresh.png"), u'Refrescar', self)
		self.action_about = QtGui.QAction(QtGui.QIcon(ruta_images+"images/icn_info.png"), u'Acerca de', self)
		self.action_quit = QtGui.QAction(QtGui.QIcon(ruta_images+"images/icn_salir.png"), u'Salir', self)

		#Genera los bookmarks y los tags
		boomarks_generar()
		#Crea el menu de tags y bookmarks
		for tag in sort_keys:
			self.submenu = QtGui.QMenu(tag, self)
			self.submenu.setIcon(QtGui.QIcon(ruta_images+"images/icn_folder.png"))
			for book in direcciones[tag]:
				#Establece el nombre del submenu
				self.action_submenu_url = QtGui.QAction(QtGui.QIcon(ruta_images+"images/icn_bookmark.png"),book.name, self)
				#Establece el enlace
				self.action_submenu_url.setData(QtCore.QVariant(book.link))
				#Asocia la accion al submenu
				self.connect(self.action_submenu_url, QtCore.SIGNAL("triggered()"), self.mnuOpenUrl)
				#Añade el link al submenu
				self.submenu.addAction(self.action_submenu_url)
			#Finalmente añade el submenu al trayicon
			self.trayMenu.addMenu(self.submenu)

		self.trayMenu.addSeparator()
		self.trayMenu.addAction(self.action_configure)
		self.trayMenu.addAction(self.action_refresh)
		self.trayMenu.addAction(self.action_about)
		self.trayMenu.addAction(self.action_quit)

		self.connect(self.action_configure, QtCore.SIGNAL("triggered()"), self.mnuConfigurar)
		self.connect(self.action_refresh, QtCore.SIGNAL("triggered()"), self.mnuRefrescar)
		self.connect(self.action_about, QtCore.SIGNAL("triggered()"), self.mnuAbout)
		self.connect(self.action_quit, QtCore.SIGNAL("triggered()"), self.mnuQuit)
		self.connect(self.tray, QtCore.SIGNAL("activated(QSystemTrayIcon::ActivationReason)"),self.mnuOpenBusqueda)

	def mnuOpenBusqueda(self, reason):
		if reason == QtGui.QSystemTrayIcon.DoubleClick:
			self.frmbuscar=FrmBuscar()
			self.frmbuscar.setWindowFlags(QtCore.Qt.WindowStaysOnTopHint)
			self.frmbuscar.show()
			self.frmbuscar.exec_()

	def mnuOpenUrl(self):
		action = self.sender()
		url=action.data().toByteArray()
		webbrowser.open_new_tab(str(url))
		
	def mnuConfigurar(self):
		self.frmconfigurar=FrmConfigurar()
		self.frmconfigurar.setWindowFlags(QtCore.Qt.WindowStaysOnTopHint)
		self.frmconfigurar.show()
		self.frmconfigurar.exec_()
		
	def mnuRefrescar(self):
		bookmarks_leer()
		self.CrearMenu()
		self.tray.setContextMenu(self.trayMenu)

	def mnuAbout(self):
		QtGui.QMessageBox.about(self, "Acerca de %s" % prog_name,u"""%(prog)s version %(version)s
Copyright \N{COPYRIGHT SIGN} 2007 Lorenzo Tejera
Visualizador de boomarks de google con buscador.

%(prog)s is free software. It is licensed under the GNU General Public License (GPL) version 3. 
This means you are free to use it and to modify it, but if you distribute your modifications you must 
distribute the modified source code as well.""" % {"prog": prog_name, "version": prog_version})

	def mnuQuit(self):
		print u"Cerrando aplicacion..."
		lock_f.release()
		sys.exit()

def bookmarks_leer():
	global bookmarks
	h = httplib2.Http()    

	configuracion=configFile()
	if(configuracion.cfg_usuario<>'' and configuracion.cfg_password<>''):
		h.add_credentials(configuracion.cfg_usuario, configuracion.cfg_password)

		try:
			print u"Leyendo bookmarks.."
			resp, content = h.request(url, "POST", body="nt", headers={'content-type':'text/plain'} )  
		except:
			lock_f.release()
			sys.exit()
		else:
			bookmarks = feedparser.parse(content)
	else:
		bookmarks=None

def bookmarks_comparar(a, b):  
	return cmp(a.name, b.name)  

def boomarks_generar():
	global sort_keys
	global direcciones

	sort_keys = []
	direcciones = dict()

	if bookmarks<>None:
		for feed in bookmarks.entries:
			book_titulo=get_value_from_dict(feed, "title")
			book_link=get_value_from_dict(feed, "link")
			book_label=get_value_from_dict(feed, "smh_bkmk_label")
			try:  
				direcciones[book_label].append(Bookmark(book_titulo, book_link))  
			except KeyError:  
				direcciones[book_label] = [Bookmark(book_titulo, book_link)]  
				sort_keys.append(book_label)

		#Ordena los tags
		sort_keys.sort()
		#Ordena los enlaces dentro del su tag correspondiente
		for key in sort_keys:  
			direcciones[key].sort(bookmarks_comparar)  

def get_value_from_dict(dict, key):
    try:
        return dict[key] 
    except KeyError:
        return ""

def Mensaje_Critico(self,mensaje):
	reply = QtGui.QMessageBox.critical(self, self.tr("Error"),mensaje, self.tr("&Aceptar"))

if __name__ == "__main__":
	try:
		lock_f = LockFile('/tmp/pygbookmarks.lock')
	except LockError:
		sys.exit(u'La aplicación ya esta funcionando')

	try:
		app = QtGui.QApplication(sys.argv)

		ruta_absoluta=os.path.abspath(sys.argv[0])
		fichero_programa=os.path.basename(sys.argv[0])
		ruta_images=ruta_absoluta.replace(fichero_programa,'')

		app.setOrganizationName("PyGBookmarks")
		app.setApplicationName("PyGBookmarks")

		bookmarks_leer()

		if QtGui.QSystemTrayIcon.isSystemTrayAvailable():
			print u"Iniciando aplicacion.."
			settings = QtCore.QSettings()
			settings.setValue("popupmessages", QtCore.QVariant(QtGui.QSystemTrayIcon.supportsMessages()));
		
			app.setQuitOnLastWindowClosed(0)
			myTrayicon = TrayBase()
		else:
			lock_f.release()
			sys.exit()

		sys.exit(app.exec_())
	finally:
		lock_f.release()
